Index: /branches/2014/dev_r4650_UKMO7_STARTHOUR/NEMOGCM/TOOLS/SIREN/src/grid.f90
===================================================================
--- /branches/2014/dev_r4650_UKMO7_STARTHOUR/NEMOGCM/TOOLS/SIREN/src/grid.f90	(revision 5074)
+++ /branches/2014/dev_r4650_UKMO7_STARTHOUR/NEMOGCM/TOOLS/SIREN/src/grid.f90	(revision 5075)
@@ -39,86 +238,1256 @@
 
    ! function and subroutine
-   PUBLIC :: grid_check_dom !< check domain validity 
-   PUBLIC :: grid_get_coarse_index !< get closest coarse grid indices of fine grid domain.
-   PUBLIC :: grid_is_global !< check if grid is global or not
-   PUBLIC :: grid_get_closest !< return closest coarse grid point from another point
-   PUBLIC :: grid_distance !< compute grid distance to a point
-   PUBLIC :: grid_get_fine_offset !< get fine grid offset
-   PUBLIC :: grid_check_coincidence !< check fine and coarse grid coincidence
-   PUBLIC :: grid_get_perio !< return NEMO periodicity index
-   PUBLIC :: grid_get_pivot !< return NEMO pivot point index
-   PUBLIC :: grid_add_ghost !< add ghost cell at boundaries.
-   PUBLIC :: grid_del_ghost !< delete ghost cell at boundaries.
-   PUBLIC :: grid_get_ghost !< return ghost cell factor
-   PUBLIC :: grid_split_domain !< 
-   PUBLIC :: grid_fill_small_dom !< 
-
-   PRIVATE :: grid_get_coarse_index_ff
-   PRIVATE :: grid_get_coarse_index_cf
-   PRIVATE :: grid_get_coarse_index_fc
-   PRIVATE :: grid_get_coarse_index_cc
-   PRIVATE :: grid__get_ghost_f  
-   PRIVATE :: grid__get_ghost_ll
-   PRIVATE :: grid__check_corner
+   PUBLIC :: grid_get_info             !< get information about mpp global domain (pivot, perio, ew)
+   PUBLIC :: grid_get_pivot            !< get NEMO pivot point index
+   PUBLIC :: grid_get_perio            !< get NEMO periodicity index
+   PUBLIC :: grid_get_ew_overlap       !< get East West overlap
+   PUBLIC :: grid_check_dom            !< check domain validity 
+   PUBLIC :: grid_get_coarse_index     !< get closest coarse grid indices of fine grid domain.
+   PUBLIC :: grid_is_global            !< check if grid is global or not
+   PUBLIC :: grid_is_north_fold
+   PUBLIC :: grid_get_closest          !< return closest coarse grid point from another point
+   PUBLIC :: grid_distance             !< compute grid distance to a point
+   PUBLIC :: grid_get_fine_offset      !< get fine grid offset
+   PUBLIC :: grid_check_coincidence    !< check fine and coarse grid coincidence
+   PUBLIC :: grid_add_ghost            !< add ghost cell at boundaries.
+   PUBLIC :: grid_del_ghost            !< delete ghost cell at boundaries.
+   PUBLIC :: grid_get_ghost            !< return ghost cell factor
+   PUBLIC :: grid_split_domain         !< compute closed sea domain 
+   PUBLIC :: grid_fill_small_dom       !< fill small closed sea with fill value 
+
+                                     ! get closest coarse grid indices of fine grid domain
+   PRIVATE :: grid__get_coarse_index_ff ! - using coarse and fine grid coordinates files
+   PRIVATE :: grid__get_coarse_index_cf ! - using coarse grid array of lon,lat and fine grid coordinates files
+   PRIVATE :: grid__get_coarse_index_fc ! - using coarse grid coordinates files, and fine grid array of lon,lat
+   PRIVATE :: grid__get_coarse_index_cc ! - using coarse and fine grid array of lon,lat
+
+                                     ! get offset between fine and coarse grid
+   PRIVATE :: grid__get_fine_offset_ff ! - using coarse and fine grid coordinates files
+   PRIVATE :: grid__get_fine_offset_cf ! - using coarse grid array of lon,lat and fine grid coordinates files
+   PRIVATE :: grid__get_fine_offset_fc ! - using coarse grid coordinates files, and fine grid array of lon,lat
+   PRIVATE :: grid__get_fine_offset_cc ! - using coarse and fine grid array of lon,lat
+
+                                     ! get information about global domain (pivot, perio, ew)
+   PRIVATE :: grid__get_info_mpp      ! - using mpp files structure
+   PRIVATE :: grid__get_info_file     ! - using files structure
+
+                                     ! get NEMO pivot point index
+   PRIVATE :: grid__get_pivot_mpp      ! - using mpp files structure
+   PRIVATE :: grid__get_pivot_file     ! - using files structure
+   PRIVATE :: grid__get_pivot_var      ! - using variable structure
+   PRIVATE :: grid__get_pivot_varT   ! compute NEMO pivot point index for variable on grid T 
+   PRIVATE :: grid__get_pivot_varU   ! compute NEMO pivot point index for variable on grid U
+   PRIVATE :: grid__get_pivot_varV   ! compute NEMO pivot point index for variable on grid V
+   PRIVATE :: grid__get_pivot_varF   ! compute NEMO pivot point index for variable on grid F
+
+                                     ! get NEMO periodicity index
+   PRIVATE :: grid__get_perio_mpp      ! - using mpp files structure
+   PRIVATE :: grid__get_perio_file     ! - using files structure
+   PRIVATE :: grid__get_perio_var      ! - using variable structure
+
+                                     ! get East West overlap
+   PRIVATE :: grid__get_ew_overlap_mpp  ! - using mpp files structure
+   PRIVATE :: grid__get_ew_overlap_file ! - using files structure
+   PRIVATE :: grid__get_ew_overlap_var  ! - using longitude variable structure
+
+                                    ! return ghost cell factor
+   PRIVATE :: grid__get_ghost_mpp      ! - using mpp files structure
+   PRIVATE :: grid__get_ghost_var      ! - using array of lon,lat
+   PRIVATE :: grid__check_corner    ! check that fine grid is inside coarse grid
+   PRIVATE :: grid__check_lat       ! check that fine grid latitude are inside coarse grid latitude
    
+   INTERFACE  grid_get_info
+      MODULE PROCEDURE grid__get_info_mpp
+      MODULE PROCEDURE grid__get_info_file
+   END INTERFACE grid_get_info
+
+   INTERFACE  grid_get_pivot
+      MODULE PROCEDURE grid__get_pivot_mpp
+      MODULE PROCEDURE grid__get_pivot_file
+      MODULE PROCEDURE grid__get_pivot_var
+   END INTERFACE grid_get_pivot
+
+   INTERFACE  grid_get_perio
+      MODULE PROCEDURE grid__get_perio_mpp
+      MODULE PROCEDURE grid__get_perio_file
+      MODULE PROCEDURE grid__get_perio_var
+   END INTERFACE grid_get_perio
+
+   INTERFACE  grid_get_ew_overlap
+      MODULE PROCEDURE grid__get_ew_overlap_mpp
+      MODULE PROCEDURE grid__get_ew_overlap_file
+      MODULE PROCEDURE grid__get_ew_overlap_var
+   END INTERFACE grid_get_ew_overlap
+
    INTERFACE  grid_get_ghost
-      MODULE PROCEDURE grid__get_ghost_ll
-      MODULE PROCEDURE grid__get_ghost_f
+      MODULE PROCEDURE grid__get_ghost_var
+      MODULE PROCEDURE grid__get_ghost_mpp
    END INTERFACE  grid_get_ghost
 
    INTERFACE  grid_get_coarse_index
-      MODULE PROCEDURE grid_get_coarse_index_ff
-      MODULE PROCEDURE grid_get_coarse_index_cf
-      MODULE PROCEDURE grid_get_coarse_index_fc
-      MODULE PROCEDURE grid_get_coarse_index_cc
+      MODULE PROCEDURE grid__get_coarse_index_ff
+      MODULE PROCEDURE grid__get_coarse_index_cf
+      MODULE PROCEDURE grid__get_coarse_index_fc
+      MODULE PROCEDURE grid__get_coarse_index_cc
    END INTERFACE grid_get_coarse_index
 
+   INTERFACE  grid_get_fine_offset
+      MODULE PROCEDURE grid__get_fine_offset_ff
+      MODULE PROCEDURE grid__get_fine_offset_fc
+      MODULE PROCEDURE grid__get_fine_offset_cf
+      MODULE PROCEDURE grid__get_fine_offset_cc
+   END INTERFACE grid_get_fine_offset   
+
 CONTAINS
    !-------------------------------------------------------------------
+   !> @brief This subroutine get information about global domain, given file
+   !> strucutre.
+   !>
+   !> @details
+   !> open edge files then:
+   !> - compute NEMO pivot point 
+   !> - compute NEMO periodicity
+   !> - compute East West overlap
+   !>
+   !> @note need all processor files to be there
+   !> @author J.Paul
+   !> - October, 2014- Initial Version
+   !>
+   !> @param[inout] td_file file structure 
+   !-------------------------------------------------------------------
+   SUBROUTINE grid__get_info_file(td_file)
+      IMPLICIT NONE
+      ! Argument      
+      TYPE(TFILE), INTENT(INOUT) :: td_file
+
+      ! local variable
+      INTEGER(i4) :: il_ew
+      INTEGER(i4) :: il_pivot
+      INTEGER(i4) :: il_perio
+      INTEGER(i4) :: il_attid
+
+      TYPE(TATT)  :: tl_att
+
+      TYPE(TFILE) :: tl_file
+
+      ! loop indices
+      INTEGER(i4) :: ji
+      !----------------------------------------------------------------
+      ! intialise
+      il_pivot=-1
+      il_perio=-1
+      il_ew   =-1 
+
+      ! copy structure
+      tl_file=file_copy(td_file)
+
+      ! open file to be used
+      CALL iom_open(tl_file)
+
+      IF( td_file%i_perio >= 0 .AND. td_file%i_perio <= 6 )THEN
+         il_perio=td_file%i_perio
+      ELSE
+         ! look for attribute in file
+         il_attid=att_get_index(tl_file%t_att(:),'periodicity')
+         IF( il_attid /= 0 )THEN
+            il_perio=INT(tl_file%t_att(il_attid)%d_value(1),i4)
+         ENDIF
+      ENDIF
+
+      IF( td_file%i_ew >= 0 )THEN
+         il_ew=td_file%i_ew
+      ELSE
+         ! look for attribute in file
+         il_attid=att_get_index(tl_file%t_att(:),'ew_overlap')
+         IF( il_attid /= 0 )THEN
+            il_ew=INT(tl_file%t_att(il_attid)%d_value(1),i4)
+         ENDIF
+      ENDIF
+
+      SELECT CASE(il_perio)
+      CASE(3,4)
+         il_pivot=0
+      CASE(5,6)
+         il_pivot=1
+      CASE(0,1,2)
+         il_pivot=1
+      END SELECT
+      
+      IF( il_pivot < 0 .OR. il_pivot > 1 )THEN
+         ! get pivot
+         il_pivot=grid_get_pivot(tl_file)
+      ENDIF
+
+      IF( il_perio < 0 .OR. il_perio > 6 )THEN
+         ! get periodicity
+         il_perio=grid_get_perio(tl_file, il_pivot)
+      ENDIF
+
+      IF( il_ew < 0 )THEN
+         ! get periodicity
+         il_ew=grid_get_ew_overlap(tl_file)
+      ENDIF
+
+      ! close
+      CALL iom_close(tl_file)
+
+      !save in file structure
+      td_file%i_ew=il_ew
+      td_file%i_pivot=il_pivot
+      td_file%i_perio=il_perio
+
+      ! save in variable of file structure
+      tl_att=att_init("ew_overlap",il_ew)
+      DO ji=1,td_file%i_nvar
+         IF( td_file%t_var(ji)%t_dim(jp_I)%l_use )THEN
+            CALL var_move_att(td_file%t_var(ji),tl_att)
+         ENDIF
+      ENDDO
+
+      ! clean 
+      CALL file_clean(tl_file)
+      CALL att_clean(tl_att)
+
+      IF( td_file%i_perio == -1 )THEN
+         CALL logger_fatal("GRID GET INFO: can not read or compute "//&
+         &  "domain periodicity from file "//TRIM(td_file%c_name)//"."//&
+         &  " you have to inform periodicity in namelist.")
+      ENDIF
+
+   END SUBROUTINE grid__get_info_file
+   !-------------------------------------------------------------------
+   !> @brief This subroutine get information about global domain, given mpp
+   !> strucutre.
+   !>
+   !> @details
+   !> open edge files then:
+   !> - compute NEMO pivot point 
+   !> - compute NEMO periodicity
+   !> - compute East West overlap
+   !>
+   !> @note need all processor files to be there
+   !> @author J.Paul
+   !> - October, 2014- Initial Version
+   !>
+   !> @param[in] td_mpp mpp structure 
+   !-------------------------------------------------------------------
+   SUBROUTINE grid__get_info_mpp(td_mpp)
+      IMPLICIT NONE
+      ! Argument      
+      TYPE(TMPP) , INTENT(INOUT) :: td_mpp
+
+      ! local variable
+      INTEGER(i4) :: il_ew
+      INTEGER(i4) :: il_pivot
+      INTEGER(i4) :: il_perio
+      INTEGER(i4) :: il_attid
+
+      TYPE(TATT)  :: tl_att
+
+      TYPE(TMPP)  :: tl_mpp
+
+      ! loop indices
+      INTEGER(i4) :: ji
+      INTEGER(i4) :: jj
+      !----------------------------------------------------------------
+      ! intialise
+      il_pivot=-1
+      il_perio=-1
+      il_ew   =-1
+
+      ! copy structure
+      tl_mpp=mpp_copy(td_mpp)
+      ! select edge files
+      CALL mpp_get_contour(tl_mpp)
+      ! open mpp file to be used
+      CALL iom_mpp_open(tl_mpp)
+
+      IF( td_mpp%i_perio >= 0 .AND. td_mpp%i_perio <= 6 )THEN
+         il_perio=td_mpp%i_perio
+      ELSE
+         ! look for attribute in mpp files
+         il_attid=att_get_index(tl_mpp%t_proc(1)%t_att(:),'periodicity')
+         IF( il_attid /= 0 )THEN
+            il_perio=INT(tl_mpp%t_proc(1)%t_att(il_attid)%d_value(1),i4)
+         ENDIF
+      ENDIF
+      
+      IF( td_mpp%i_ew >= 0 )THEN
+         il_ew=td_mpp%i_ew
+      ELSE
+         ! look for attribute in mpp files
+         il_attid=att_get_index(tl_mpp%t_proc(1)%t_att(:),'ew_overlap')
+         IF( il_attid /= 0 )THEN
+            il_ew=INT(tl_mpp%t_proc(1)%t_att(il_attid)%d_value(1),i4)
+         ENDIF
+      ENDIF
+
+      SELECT CASE(il_perio)
+      CASE(3,4)
+         il_pivot=0
+      CASE(5,6)
+         il_pivot=1
+      CASE(0,1,2)
+         il_pivot=1
+      END SELECT
+
+      IF( il_pivot < 0 .OR. il_pivot > 1 )THEN
+         ! get pivot
+         il_pivot=grid_get_pivot(tl_mpp)
+      ENDIF
+
+      IF( il_perio < 0 .OR. il_perio > 6 )THEN
+         ! get periodicity
+         il_perio=grid_get_perio(tl_mpp, il_pivot)
+      ENDIF
+
+      IF( il_ew < 0 )THEN
+         ! get periodicity
+         il_ew=grid_get_ew_overlap(tl_mpp)
+      ENDIF
+
+      ! close
+      CALL iom_mpp_close(tl_mpp)
+
+      !save in mpp structure
+      td_mpp%i_ew=il_ew
+      td_mpp%i_pivot=il_pivot
+      td_mpp%i_perio=il_perio
+
+      ! save in variable of mpp structure
+      IF( ASSOCIATED(td_mpp%t_proc) )THEN
+         tl_att=att_init("ew_overlap",il_ew)
+         DO jj=1,td_mpp%i_nproc
+            DO ji=1,td_mpp%t_proc(jj)%i_nvar
+               IF( td_mpp%t_proc(jj)%t_var(ji)%t_dim(jp_I)%l_use )THEN
+                  CALL var_move_att(td_mpp%t_proc(jj)%t_var(ji),tl_att)
+               ENDIF
+            ENDDO
+         ENDDO
+      ENDIF
+
+      ! clean 
+      CALL mpp_clean(tl_mpp)
+      CALL att_clean(tl_att)
+
+      IF( td_mpp%i_perio == -1 )THEN
+         CALL logger_fatal("GRID GET INFO: can not read or compute "//&
+         &  "domain periodicity from mpp "//TRIM(td_mpp%c_name)//"."//&
+         &  " you have to inform periodicity in namelist.")
+      ENDIF
+
+   END SUBROUTINE grid__get_info_mpp
+   !-------------------------------------------------------------------
    !> @brief 
-   !> This funtion return NEMO pivot point index of the input variable.
+   !> This function compute NEMO pivot point index of the input variable.
    !> - F-point : 0
    !> - T-point : 1
    !>
+   !> @details
+   !> check north points of latitude grid (indices jpj to jpj-3) depending on which grid point
+   !> (T,F,U,V) variable is defined
+   !> 
+   !> @note variable must be at least 2D variable, and should not be coordinate
+   !> variable (i.e lon, lat)
+   !> 
    !> @warning 
-   !> - variable must be nav_lon or nav_lat
    !> - do not work with ORCA2 grid (T-point)
    !>
    !> @author J.Paul
-   !> - Nov, 2013- Subroutine written
-   !
-   !> @todo 
-   !> - improve check between T or F pivot.
-   !
-   !> @param[in] td_file : file structure
-   !> @param[in] cd_varname : variable name
-   !> @return NEMO pivot point index
-   !-------------------------------------------------------------------
-   !> @code
-   INTEGER(i4) FUNCTION grid_get_pivot(td_file)
+   !> - November, 2013- Subroutine written
+   !> @date September, 2014
+   !> - add dummy loop in case variable not over right point.
+   !> @date October, 2014
+   !> - work on variable structure instead of file structure
+   !
+   !> @param[in] td_lat  latitude variable structure
+   !> @param[in] td_var  variable structure
+   !> @return pivot point index
+   !-------------------------------------------------------------------
+   FUNCTION grid__get_pivot_var(td_var)
       IMPLICIT NONE
       ! Argument      
-      TYPE(TFILE),       INTENT(IN) :: td_file
+      TYPE(TVAR), INTENT(IN) :: td_var
+
+      ! function
+      INTEGER(i4) :: grid__get_pivot_var
 
       ! local variable
-      TYPE(TVAR)                        :: tl_var
+      INTEGER(i4), DIMENSION(ip_maxdim)            :: il_dim
+
+      REAL(dp)   , DIMENSION(:,:,:,:), ALLOCATABLE :: dl_value
+
+      ! loop indices
+      INTEGER(i4) :: jj
+      !----------------------------------------------------------------
+      ! intitalise
+      grid__get_pivot_var=-1
+
+      IF( .NOT. ASSOCIATED(td_var%d_value) .OR. &
+      &   .NOT. ALL(td_var%t_dim(1:2)%l_use) )THEN
+         CALL logger_error("GRID GET PIVOT: can not compute pivot point"//&
+         &  " with variable "//TRIM(td_var%c_name)//"."//&
+         &  " no value associated or missing dimension.")
+      ELSE
+         il_dim(:)=td_var%t_dim(:)%i_len
+
+         ALLOCATE(dl_value(il_dim(1),4,1,1))
+         ! extract value
+         dl_value(:,:,:,:)=td_var%d_value( 1:il_dim(1),          &
+         &                                 il_dim(2)-3:il_dim(2),&
+         &                                 1:1,                  &
+         &                                 1:1 )
+
+         SELECT CASE(TRIM(td_var%c_point))
+         CASE('T')
+            grid__get_pivot_var=grid__get_pivot_varT(dl_value)
+         CASE('U')
+            grid__get_pivot_var=grid__get_pivot_varU(dl_value)
+         CASE('V')
+            grid__get_pivot_var=grid__get_pivot_varV(dl_value)
+         CASE('F')
+            grid__get_pivot_var=grid__get_pivot_varF(dl_value)
+         END SELECT
+
+         ! dummy loop in case variable not over right point 
+         ! (ex: nav_lon over U-point)
+         IF( grid__get_pivot_var == -1 )THEN
+            
+            ! no pivot point found
+            CALL logger_error("GRID GET PIVOT: something wrong "//&
+            &  "when computing pivot point with variable "//&
+            &  TRIM(td_var%c_name))
+
+            DO jj=1,ip_npoint
+               SELECT CASE(TRIM(cp_grid_point(jj)))
+               CASE('T')
+                  CALL logger_debug("GRID GET PIVOT: check variable on point T")
+                  grid__get_pivot_var=grid__get_pivot_varT(dl_value)
+               CASE('U')
+                  CALL logger_debug("GRID GET PIVOT: check variable on point U")
+                  grid__get_pivot_var=grid__get_pivot_varU(dl_value)
+               CASE('V')
+                  CALL logger_debug("GRID GET PIVOT: check variable on point V")
+                  grid__get_pivot_var=grid__get_pivot_varV(dl_value)
+               CASE('F')
+                  CALL logger_debug("GRID GET PIVOT: check variable on point F")
+                  grid__get_pivot_var=grid__get_pivot_varF(dl_value)
+               END SELECT
+
+               IF( grid__get_pivot_var /= -1 )THEN
+                  CALL logger_warn("GRID GET PIVOT: variable "//&
+                  &  TRIM(td_var%c_name)//" seems to be on grid point "//&
+                  &  TRIM(cp_grid_point(jj)) )
+                  EXIT
+               ENDIF
+
+            ENDDO
+         ENDIF
+
+         IF( grid__get_pivot_var == -1 )THEN
+            CALL logger_warn("GRID GET PIVOT: not able to found pivot point. "//&
+            &  "Force to use pivot point T.")
+            grid__get_pivot_var = 1
+         ENDIF
+
+         ! clean
+         DEALLOCATE(dl_value)
+
+      ENDIF
+
+   END FUNCTION grid__get_pivot_var
+   !-------------------------------------------------------------------
+   !> @brief 
+   !> This function compute NEMO pivot point index for variable on grid T.
+   !>
+   !> @details
+   !> - F-point : 0
+   !> - T-point : 1
+   !>
+   !> @note array of value must be only the top border of the domain.
+   !> 
+   !> @author J.Paul
+   !> - October, 2014 - Initial version
+   !
+   !> @param[in] dd_value array of value
+   !> @return pivot point index
+   !-------------------------------------------------------------------
+   FUNCTION grid__get_pivot_varT(dd_value)
+      IMPLICIT NONE
+      ! Argument      
+      REAL(dp), DIMENSION(:,:,:,:), INTENT(IN) :: dd_value
+
+      ! function
+      INTEGER(i4) :: grid__get_pivot_varT
+
+      ! local variable
+      INTEGER(i4)                       :: il_midT
+      INTEGER(i4)                       :: il_midF
+
+      INTEGER(i4)                       :: it1
+      INTEGER(i4)                       :: it2
+      INTEGER(i4)                       :: jt1
+      INTEGER(i4)                       :: jt2
+
+      INTEGER(i4)                       :: if1
+      INTEGER(i4)                       :: if2
+      INTEGER(i4)                       :: jf1
+      INTEGER(i4)                       :: jf2
+
+      INTEGER(i4), DIMENSION(ip_maxdim) :: il_dim
+
+      LOGICAL                           :: ll_check
+
+      ! loop indices
+      INTEGER(i4) :: ji
+      !----------------------------------------------------------------
+      ! intitalise
+      grid__get_pivot_varT=-1
+
+      il_dim(:)=SHAPE(dd_value(:,:,:,:))
+
+      ! T-point pivot !case of ORCA2, ORCA025, ORCA12 grid
+      jt1=4  ; jt2=2 
+      il_midT=il_dim(1)/2+1
+
+      ! F-point pivot !case of ORCA05 grid
+      jf1=4 ; jf2=3
+      il_midF=il_dim(1)/2
+
+      ! check T-point pivot
+      DO ji=2,il_midT
+         ll_check=.TRUE.
+         it1=ji
+         it2=il_dim(1)-(ji-2)
+         IF( dd_value(it1,jt1,1,1) /= dd_value(it2,jt2,1,1) )THEN
+            ll_check=.FALSE.
+            EXIT
+         ENDIF
+      ENDDO
+
+      IF( ll_check )THEN
+         CALL logger_info("GRID GET PIVOT: T-pivot")
+         grid__get_pivot_varT=1
+      ELSE
+
+         ! check F-point pivot
+         DO ji=1,il_midF
+            ll_check=.TRUE.
+            if1=ji
+            if2=il_dim(1)-(ji-1)
+            IF( dd_value(if1,jf1,1,1) /= dd_value(if2,jf2,1,1) )THEN
+               ll_check=.FALSE.
+               EXIT
+            ENDIF
+         ENDDO
+
+         IF( ll_check )THEN
+            CALL logger_info("GRID GET PIVOT: T-pivot")
+            grid__get_pivot_varT=0
+         ENDIF
+
+      ENDIF
+
+   END FUNCTION grid__get_pivot_varT
+   !-------------------------------------------------------------------
+   !> @brief 
+   !> This function compute NEMO pivot point index for variable on grid U.
+   !>
+   !> @details
+   !> - F-point : 0
+   !> - T-point : 1
+   !>
+   !> @note array of value must be only the top border of the domain.
+   !> 
+   !> @author J.Paul
+   !> - October, 2014 - Initial version
+   !
+   !> @param[in] dd_value array of value
+   !> @return pivot point index
+   !-------------------------------------------------------------------
+   FUNCTION grid__get_pivot_varU(dd_value)
+      IMPLICIT NONE
+      ! Argument      
+      REAL(dp), DIMENSION(:,:,:,:), INTENT(IN) :: dd_value
+
+      ! function
+      INTEGER(i4) :: grid__get_pivot_varU
+
+      ! local variable
+      INTEGER(i4)                       :: il_midT
+      INTEGER(i4)                       :: il_midF
+
+      INTEGER(i4)                       :: it1
+      INTEGER(i4)                       :: it2
+      INTEGER(i4)                       :: jt1
+      INTEGER(i4)                       :: jt2
+
+      INTEGER(i4)                       :: if1
+      INTEGER(i4)                       :: if2
+      INTEGER(i4)                       :: jf1
+      INTEGER(i4)                       :: jf2
+
+      INTEGER(i4), DIMENSION(ip_maxdim) :: il_dim
+
+      LOGICAL                           :: ll_check
+
+      ! loop indices
+      INTEGER(i4) :: ji
+      !----------------------------------------------------------------
+      ! intitalise
+      grid__get_pivot_varU=-1
+
+      il_dim(:)=SHAPE(dd_value(:,:,:,:))
+
+      ! T-point pivot !case of ORCA2, ORCA025, ORCA12 grid
+      jt1=4 ; jt2=2 
+      il_midT=il_dim(1)/2+1
+
+      ! F-point pivot !case of ORCA05 grid
+      jf1=4 ; jf2=3
+      il_midF=il_dim(1)/2
+
+      ! check T-point pivot
+      DO ji=1,il_midT
+         ll_check=.TRUE.
+         it1=ji
+         it2=il_dim(1)-(ji-2)
+         IF( dd_value(it1,jt1,1,1) /= dd_value(it2-1,jt2,1,1) )THEN
+            ll_check=.FALSE.
+            EXIT
+         ENDIF
+      ENDDO
+
+      IF( ll_check )THEN
+         CALL logger_info("GRID GET PIVOT: T-pivot")
+         grid__get_pivot_varU=1
+      ELSE
+
+         ! check F-point pivot
+         DO ji=1,il_midF
+            ll_check=.TRUE.
+            if1=ji
+            if2=il_dim(1)-(ji-1)
+            IF( dd_value(if1,jf1,1,1) /= dd_value(if2-1,jf2,1,1) )THEN
+               ll_check=.FALSE.
+               EXIT
+            ENDIF
+         ENDDO
+
+         IF( ll_check )THEN
+            CALL logger_info("GRID GET PIVOT: T-pivot")
+            grid__get_pivot_varU=0
+         ENDIF
+
+      ENDIF
+
+   END FUNCTION grid__get_pivot_varU
+   !-------------------------------------------------------------------
+   !> @brief 
+   !> This function compute NEMO pivot point index for variable on grid V.
+   !>
+   !> @details
+   !> - F-point : 0
+   !> - T-point : 1
+   !>
+   !> @note array of value must be only the top border of the domain.
+   !> 
+   !> @author J.Paul
+   !> - October, 2014 - Initial version
+   !
+   !> @param[in] dd_value array of value
+   !> @return pivot point index
+   !-------------------------------------------------------------------
+   FUNCTION grid__get_pivot_varV(dd_value)
+      IMPLICIT NONE
+      ! Argument      
+      REAL(dp), DIMENSION(:,:,:,:), INTENT(IN) :: dd_value
+
+      ! function
+      INTEGER(i4) :: grid__get_pivot_varV
+
+      ! local variable
+      INTEGER(i4)                       :: il_midT
+      INTEGER(i4)                       :: il_midF
+
+      INTEGER(i4)                       :: it1
+      INTEGER(i4)                       :: it2
+      INTEGER(i4)                       :: jt1
+      INTEGER(i4)                       :: jt2
+
+      INTEGER(i4)                       :: if1
+      INTEGER(i4)                       :: if2
+      INTEGER(i4)                       :: jf1
+      INTEGER(i4)                       :: jf2
+
+      INTEGER(i4), DIMENSION(ip_maxdim) :: il_dim
+
+      LOGICAL                           :: ll_check
+
+      ! loop indices
+      INTEGER(i4) :: ji
+      !----------------------------------------------------------------
+      ! intitalise
+      grid__get_pivot_varV=-1
+
+      il_dim(:)=SHAPE(dd_value(:,:,:,:))
+
+      ! T-point pivot !case of ORCA2, ORCA025, ORCA12 grid
+      jt1=4 ; jt2=2 
+      il_midT=il_dim(1)/2+1
+
+      ! F-point pivot !case of ORCA05 grid
+      jf1=4 ; jf2=3
+      il_midF=il_dim(1)/2
+
+      ! check T-point pivot
+      DO ji=2,il_midT
+         ll_check=.TRUE.
+         it1=ji
+         it2=il_dim(1)-(ji-2)
+         IF( dd_value(it1,jt1,1,1) /= dd_value(it2,jt2-1,1,1) )THEN
+            ll_check=.FALSE.
+            EXIT
+         ENDIF
+      ENDDO
+
+      IF( ll_check )THEN
+         CALL logger_info("GRID GET PIVOT: T-pivot")
+         grid__get_pivot_varV=1
+      ELSE
+
+         ! check F-point pivot
+         DO ji=1,il_midF
+            ll_check=.TRUE.
+            if1=ji
+            if2=il_dim(1)-(ji-1)
+            IF( dd_value(if1,jf1,1,1) /= dd_value(if2,jf2-1,1,1) )THEN
+               ll_check=.FALSE.
+               EXIT
+            ENDIF
+         ENDDO
+
+         IF( ll_check )THEN
+            CALL logger_info("GRID GET PIVOT: T-pivot")
+            grid__get_pivot_varV=0
+         ENDIF
+
+      ENDIF
+
+   END FUNCTION grid__get_pivot_varV
+   !-------------------------------------------------------------------
+   !> @brief 
+   !> This function compute NEMO pivot point index for variable on grid F.
+   !>
+   !> @details
+   !> - F-point : 0
+   !> - T-point : 1
+   !>
+   !> @note array of value must be only the top border of the domain.
+   !> 
+   !> @author J.Paul
+   !> - October, 2014 - Initial version
+   !
+   !> @param[in] dd_value array of value
+   !> @return pivot point index
+   !-------------------------------------------------------------------
+   FUNCTION grid__get_pivot_varF(dd_value)
+      IMPLICIT NONE
+      ! Argument      
+      REAL(dp), DIMENSION(:,:,:,:), INTENT(IN) :: dd_value
+
+      ! function
+      INTEGER(i4) :: grid__get_pivot_varF
+
+      ! local variable
+      INTEGER(i4)                       :: il_midT
+      INTEGER(i4)                       :: il_midF
+
+      INTEGER(i4)                       :: it1
+      INTEGER(i4)                       :: it2
+      INTEGER(i4)                       :: jt1
+      INTEGER(i4)                       :: jt2
+
+      INTEGER(i4)                       :: if1
+      INTEGER(i4)                       :: if2
+      INTEGER(i4)                       :: jf1
+      INTEGER(i4)                       :: jf2
+
+      INTEGER(i4), DIMENSION(ip_maxdim) :: il_dim
+
+      LOGICAL                           :: ll_check
+
+      ! loop indices
+      INTEGER(i4) :: ji
+      !----------------------------------------------------------------
+      ! intitalise
+      grid__get_pivot_varF=-1
+
+      il_dim(:)=SHAPE(dd_value(:,:,:,:))
+
+      ! T-point pivot !case of ORCA2, ORCA025, ORCA12 grid
+      jt1=4 ; jt2=2 
+      il_midT=il_dim(1)/2+1
+
+      ! F-point pivot !case of ORCA05 grid
+      jf1=4 ; jf2=3
+      il_midF=il_dim(1)/2
+
+      ! check T-point pivot
+      DO ji=1,il_midT
+         ll_check=.TRUE.
+         it1=ji
+         it2=il_dim(1)-(ji-2)
+         IF( dd_value(it1,jt1,1,1) /= dd_value(it2-1,jt2-1,1,1) )THEN
+            ll_check=.FALSE.
+            EXIT
+         ENDIF
+      ENDDO
+
+      IF( ll_check )THEN
+         CALL logger_info("GRID GET PIVOT: T-pivot")
+         grid__get_pivot_varF=1
+      ELSE
+
+         ! check F-point pivot
+         DO ji=1,il_midF
+            ll_check=.TRUE.
+            if1=ji
+            if2=il_dim(1)-(ji-1)
+            IF( dd_value(if1,jf1,1,1) /= dd_value(if2-1,jf2-1,1,1) )THEN
+               ll_check=.FALSE.
+               EXIT
+            ENDIF
+         ENDDO
+
+         IF( ll_check )THEN
+            CALL logger_info("GRID GET PIVOT: T-pivot")
+            grid__get_pivot_varF=0
+         ENDIF
+
+      ENDIF
+
+   END FUNCTION grid__get_pivot_varF
+   !-------------------------------------------------------------------
+   !> @brief 
+   !> This function compute NEMO pivot point index from input file variable.
+   !> - F-point : 0
+   !> - T-point : 1
+   !>
+   !> @details
+   !> check north points of latitude grid (indices jpj to jpj-3) depending on which grid point
+   !> (T,F,U,V) variable is defined
+   !> 
+   !> @warning 
+   !> - do not work with ORCA2 grid (T-point)
+   !>
+   !> @author J.Paul
+   !> - Ocotber, 2014- Initial version
+   !
+   !> @param[in] td_file file structure
+   !> @return pivot point index
+   !-------------------------------------------------------------------
+   FUNCTION grid__get_pivot_file(td_file)
+      IMPLICIT NONE
+      ! Argument      
+      TYPE(TFILE), INTENT(IN) :: td_file
+
+      ! function
+      INTEGER(i4) :: grid__get_pivot_file
+
+      ! local variable
       INTEGER(i4)                       :: il_varid
       INTEGER(i4), DIMENSION(ip_maxdim) :: il_dim
 
+      LOGICAL                           :: ll_north
+
+      TYPE(TVAR)                        :: tl_var
+      TYPE(TVAR)                        :: tl_lat
+
       ! loop indices
       INTEGER(i4) :: ji
-
-      INTEGER(i4) :: it1
-      INTEGER(i4) :: it2
-      INTEGER(i4) :: jt1
-      INTEGER(i4) :: jt2
-
-      INTEGER(i4) :: if1
-      INTEGER(i4) :: if2
-      INTEGER(i4) :: jf1
-      INTEGER(i4) :: jf2
       !----------------------------------------------------------------
-      ! initialise
-      grid_get_pivot=-1
+      ! intitalise
+      grid__get_pivot_file=-1
+
+      ! look for north fold
+      il_varid=var_get_index(td_file%t_var(:), 'latitude')
+      IF( il_varid == 0 )THEN
+         CALL logger_error("GRID GET PIVOT: no variable with name "//&
+         &  "or standard name latitude in file structure "//&
+         &  TRIM(td_file%c_name))
+      ENDIF
+      IF( ASSOCIATED(td_file%t_var(il_varid)%d_value) )THEN
+         tl_lat=var_copy(td_file%t_var(il_varid))
+      ELSE
+         tl_lat=iom_read_var(td_file, 'latitude')
+      ENDIF
+
+      ll_north=grid_is_north_fold(tl_lat)
+      ! clean
+      CALL var_clean(tl_lat)
+
+      IF( ll_north )THEN      
+         ! look for suitable variable
+         DO ji=1,td_file%i_nvar
+            IF( .NOT. ALL(td_file%t_var(ji)%t_dim(1:2)%l_use) ) CYCLE
+
+            IF( ASSOCIATED(td_file%t_var(ji)%d_value) )THEN
+               tl_var=var_copy(td_file%t_var(ji))
+            ELSE
+               il_dim(:)=td_file%t_var(ji)%t_dim(:)%i_len
+               tl_var=iom_read_var(td_file, &
+               &                   td_file%t_var(ji)%c_name, &
+               &                   id_start=(/1,il_dim(2)-3,1,1/), &
+               &                   id_count=(/il_dim(1),4,1,1/) )
+            ENDIF
+         ENDDO
+
+         IF( ASSOCIATED(tl_var%d_value) )THEN
+
+            grid__get_pivot_file=grid_get_pivot(tl_var)
+
+         ENDIF
+
+         ! clean
+         CALL var_clean(tl_var)
+      ELSE
+         CALL logger_warn("GRID GET PIVOT: no north fold. force to use T-PIVOT")
+         grid__get_pivot_file=1
+      ENDIF
+
+   END FUNCTION grid__get_pivot_file
+   !-------------------------------------------------------------------
+   !> @brief 
+   !> This function compute NEMO pivot point index from input mpp variable.
+   !> - F-point : 0
+   !> - T-point : 1
+   !>
+   !> @details
+   !> check north points of latitude grid (indices jpj to jpj-3) depending on which grid point
+   !> (T,F,U,V) variable is defined
+   !> 
+   !> @warning 
+   !> - do not work with ORCA2 grid (T-point)
+   !>
+   !> @author J.Paul
+   !> - October, 2014 - Initial version
+   !
+   !> @param[in] td_mpp   mpp file structure
+   !> @return pivot point index
+   !-------------------------------------------------------------------
+   FUNCTION grid__get_pivot_mpp(td_mpp)
+      IMPLICIT NONE
+      ! Argument      
+      TYPE(TMPP), INTENT(IN) :: td_mpp
+
+      ! function
+      INTEGER(i4) :: grid__get_pivot_mpp
+
+      ! local variable
+      INTEGER(i4)                       :: il_varid
+      INTEGER(i4), DIMENSION(ip_maxdim) :: il_dim
+
+      LOGICAL                           :: ll_north
+
+      TYPE(TVAR)                        :: tl_var
+      TYPE(TVAR)                        :: tl_lat
+ 
+      ! loop indices
+      INTEGER(i4) :: ji
+      !----------------------------------------------------------------
+      ! intitalise
+      grid__get_pivot_mpp=-1
+
+      ! look for north fold
+      il_varid=var_get_index(td_mpp%t_proc(1)%t_var(:), 'latitude')
+      IF( il_varid == 0 )THEN
+         CALL logger_error("GRID GET PIVOT: no variable with name "//&
+         &  "or standard name latitude in mpp structure "//&
+         &  TRIM(td_mpp%c_name)//". Assume there is north fold and "//&
+         &  "try to get pivot point")
+
+         ll_north=.TRUE.
+      ELSE
+         IF( ASSOCIATED(td_mpp%t_proc(1)%t_var(il_varid)%d_value) )THEN
+            ! 
+            tl_lat=mpp_recombine_var(td_mpp, 'latitude')
+         ELSE
+            tl_lat=iom_mpp_read_var(td_mpp, 'latitude')
+         ENDIF      
+
+         ll_north=grid_is_north_fold(tl_lat)
+      ENDIF
+
+      IF( ll_north )THEN
+
+         IF( ASSOCIATED(tl_lat%d_value) )THEN
+            grid__get_pivot_mpp=grid_get_pivot(tl_lat)
+         ELSE
+            ! look for suitable variable
+            DO ji=1,td_mpp%t_proc(1)%i_nvar
+               IF(.NOT. ALL(td_mpp%t_proc(1)%t_var(ji)%t_dim(1:2)%l_use)) CYCLE
+
+               IF( ASSOCIATED(td_mpp%t_proc(1)%t_var(ji)%d_value) )THEN
+                  CALL logger_debug("GRID GET PIVOT: mpp_recombine_var"//&
+                  &         TRIM(td_mpp%t_proc(1)%t_var(ji)%c_name))
+                  tl_var=mpp_recombine_var(td_mpp, &
+                  &              TRIM(td_mpp%t_proc(1)%t_var(ji)%c_name))
+               ELSE
+                  CALL logger_debug("GRID GET PIVOT: iom_mpp_read_var "//&
+                  &        TRIM(td_mpp%t_proc(1)%t_var(ji)%c_name))
+                  il_dim(:)=td_mpp%t_dim(:)%i_len
+
+                  ! read variable
+                  tl_var=iom_mpp_read_var(td_mpp, &
+                  &                       td_mpp%t_proc(1)%t_var(ji)%c_name, &
+                  &                       id_start=(/1,il_dim(2)-3,1,1/), &
+                  &                       id_count=(/il_dim(1),4,1,1/) )
+               ENDIF
+               EXIT
+            ENDDO
+
+            IF( ASSOCIATED(tl_var%d_value) )THEN
+
+               grid__get_pivot_mpp=grid_get_pivot(tl_var)
+
+           ELSE
+               CALL logger_warn("GRID GET PIVOT: force to use T-PIVOT")
+               grid__get_pivot_mpp=1
+            ENDIF
+
+            ! clean
+            CALL var_clean(tl_var)
+         ENDIF
+      ELSE
+         CALL logger_warn("GRID GET PIVOT: no north fold. force to use T-PIVOT")
+         grid__get_pivot_mpp=1
+      ENDIF
+
+      CALL var_clean(tl_lat)
+   END FUNCTION grid__get_pivot_mpp
+   !-------------------------------------------------------------------
+   !> @brief 
+   !> This subroutine search NEMO periodicity index given variable structure and
+   !> pivot point index.
+   !> @details
+   !> The variable must be on T point.
+   !>
+   !> 0: closed boundaries
+   !> 1: cyclic east-west boundary
+   !> 2: symmetric boundary condition across the equator
+   !> 3: North fold boundary (with a F-point pivot)
+   !> 4: North fold boundary (with a F-point pivot) and cyclic east-west boundary
+   !> 5: North fold boundary (with a T-point pivot)
+   !> 6: North fold boundary (with a T-point pivot) and cyclic east-west boundary
+   !>
+   !> @warning pivot point should have been computed before run this script. see grid_get_pivot.
+   !>
+   !> @author J.Paul
+   !> - November, 2013- Subroutine written
+   !> @date October, 2014
+   !> - work on variable structure instead of file structure
+   !
+   !> @param[in] td_var   variable structure
+   !> @param[in] id_pivot pivot point index
+   !-------------------------------------------------------------------
+   FUNCTION grid__get_perio_var(td_var, id_pivot)
+      IMPLICIT NONE
+
+      ! Argument      
+      TYPE(TVAR) , INTENT(IN) :: td_var
+      INTEGER(i4), INTENT(IN) :: id_pivot
+
+      ! function
+      INTEGER(i4) :: grid__get_perio_var
+
+      ! local variable
+      INTEGER(i4)                       :: il_perio
+
+      INTEGER(i4), DIMENSION(ip_maxdim) :: il_dim
+
+      ! loop indices
+      !----------------------------------------------------------------
+      ! intitalise
+      grid__get_perio_var=-1
+
+      IF( id_pivot < 0 .OR. id_pivot > 1 )THEN
+         CALL logger_error("GRID GET PERIO: invalid pivot point index. "//&
+         &  "you should use grid_get_pivot to compute it")
+      ENDIF
+
+      IF( .NOT. ASSOCIATED(td_var%d_value) .OR. &
+      &   .NOT. ALL(td_var%t_dim(1:2)%l_use) )THEN
+         CALL logger_error("GRID GET PERIO: can not compute periodicity"//&
+         &  " with variable "//TRIM(td_var%c_name)//"."//&
+         &  " no value associated or missing dimension.")
+      ELSE
+
+         il_dim(:)=td_var%t_dim(:)%i_len
+
+         CALL logger_info("GRID GET PERIO: use varibale "//TRIM(td_var%c_name))
+         CALL logger_info("GRID GET PERIO: fill value "//TRIM(fct_str(td_var%d_fill)))
+         CALL logger_info("GRID GET PERIO: fill value "//TRIM(fct_str(td_var%d_value(1,1,1,1))))
+
+         IF(ALL(td_var%d_value(    1    ,    :    ,1,1)/=td_var%d_fill).AND.&
+         &  ALL(td_var%d_value(il_dim(1),    :    ,1,1)/=td_var%d_fill).AND.&
+         &  ALL(td_var%d_value(    :    ,    1    ,1,1)/=td_var%d_fill).AND.&
+         &  ALL(td_var%d_value(    :    ,il_dim(2),1,1)/=td_var%d_fill))THEN
+         ! no boundary closed
+            CALL logger_warn("GRID GET PERIO: can't determined periodicity. "//&
+            &             "there is no boundary closed for variable "//&
+            &              TRIM(td_var%c_name) )
+         ELSE
+            ! check periodicity
+            IF(ANY(td_var%d_value(   1     ,:,1,1)/=td_var%d_fill).OR.&
+            &  ANY(td_var%d_value(il_dim(1),:,1,1)/=td_var%d_fill))THEN
+            ! East-West cyclic (1,4,6)
+
+               IF( ANY(td_var%d_value(:, 1, 1, 1) /= td_var%d_fill) )THEN
+               ! South boundary not closed 
+
+                  CALL logger_debug("GRID GET PERIO: East_West cyclic")
+                  CALL logger_debug("GRID GET PERIO: South boundary not closed")
+                  CALL logger_error("GRID GET PERIO: should have been an "//&
+                  &              "impossible case")
+
+               ELSE
+               ! South boundary closed (1,4,6)
+                  CALL logger_info("GRID GET PERIO: South boundary closed")
+
+                  IF(ANY(td_var%d_value(:,il_dim(2),1,1)/=td_var%d_fill) )THEN
+                  ! North boundary not closed (4,6)
+                     CALL logger_info("GRID GET PERIO: North boundary not closed")
+                     ! check pivot
+                     SELECT CASE(id_pivot)
+                        CASE(0)
+                           ! F pivot
+                           il_perio=6
+                        CASE(1)
+                           ! T pivot
+                           il_perio=4
+                        CASE DEFAULT
+                           CALL logger_error("GRID GET PERIO: invalid pivot ")
+                     END SELECT
+                  ELSE
+                  ! North boundary closed
+                     CALL logger_info("GRID GET PERIO: North boundary closed")
+                     il_perio=1 ! North and South boundaries closed
+                  ENDIF
+
+               ENDIF
+
+            ELSE
+            ! East-West boundaries closed (0,2,3,5)
+               CALL logger_info("GRID GET PERIO: East West boundaries closed")
+
+               IF( ANY(td_var%d_value(:, 1, 1, 1) /= td_var%d_fill) )THEN
+               ! South boundary not closed (2)
+                  CALL logger_info("GRID GET PERIO: South boundary not closed")
+
+                  IF(ANY(td_var%d_value(:,il_dim(2),1,1)/=td_var%d_fill))THEN
+                  ! North boundary not closed
+                     CALL logger_debug("GRID GET PERIO: East West boundaries "//&
+                     &              "closed")
+                     CALL logger_debug("GRID GET PERIO: South boundary not closed")
+                     CALL logger_debug("GRID GET PERIO: North boundary not closed")
+                     CALL logger_error("GRID GET PERIO: should have been "//&
+                     &              "an impossible case")
+                  ELSE
+                  ! North boundary closed
+                     il_perio=2   ! East-West and North boundaries closed 
+                  ENDIF
+
+               ELSE
+               ! South boundary closed (0,3,5)
+                  CALL logger_info("GRID GET PERIO: South boundary closed")
+
+                  IF(ANY(td_var%d_value(:,il_dim(2),1,1)/=td_var%d_fill))THEN
+                  ! North boundary not closed (3,5)
+                     CALL logger_info("GRID GET PERIO: North boundary not closed")
+                     ! check pivot
+                     SELECT CASE(id_pivot)
+                        CASE(0)
+                           ! F pivot
+                           il_perio=5
+                        CASE(1)
+                           ! T pivot
+                           il_perio=3
+                        CASE DEFAULT
+                           CALL logger_error("GRID GET PERIO: invalid pivot")
+                     END SELECT
+                  ELSE
+                  ! North boundary closed   
+                     CALL logger_info("GRID GET PERIO: North boundary closed")
+                     il_perio=0   ! all boundary closed
+                  ENDIF
+
+               ENDIF
+
+            ENDIF
+
+            grid__get_perio_var=il_perio
+
+         ENDIF
+
+      ENDIF
+
+   END FUNCTION grid__get_perio_var
+   !-------------------------------------------------------------------
+   !> @brief 
+   !> This subroutine search NEMO periodicity index given file structure, and
+   !> optionaly pivot point index.
+   !> @details
+   !> The variable used must be on T point.
+   !>
+   !> 0: closed boundaries
+   !> 1: cyclic east-west boundary
+   !> 2: symmetric boundary condition across the equator
+   !> 3: North fold boundary (with a F-point pivot)
+   !> 4: North fold boundary (with a F-point pivot) and cyclic east-west boundary
+   !> 5: North fold boundary (with a T-point pivot)
+   !> 6: North fold boundary (with a T-point pivot) and cyclic east-west boundary
+   !>
+   !> @warning pivot point should have been computed before run this script. see grid_get_pivot.
+   !>
+   !> @author J.Paul
+   !> - October, 2014 - Initial version
+   !>
+   !> @param[in] td_file   file structure
+   !> @param[in] id_pivot  pivot point index
+   !-------------------------------------------------------------------
+   FUNCTION grid__get_perio_file(td_file, id_pivot)
+      IMPLICIT NONE
+
+      ! Argument      
+      TYPE(TFILE), INTENT(IN) :: td_file
+      INTEGER(i4), INTENT(IN), OPTIONAL :: id_pivot
+
+      ! function
+      INTEGER(i4) :: grid__get_perio_file
+
+      ! local variable
+      INTEGER(i4)                       :: il_varid
+      INTEGER(i4)                       :: il_pivot
+      INTEGER(i4), DIMENSION(ip_maxdim) :: il_dim
+
+      TYPE(TVAR)                        :: tl_var
+
+      ! loop indices
+      INTEGER(i4) :: ji
+      !----------------------------------------------------------------
+      !initialise
+      grid__get_perio_file=-1
+
+      IF(PRESENT(id_pivot) )THEN
+         il_pivot=id_pivot
+      ELSE
+         il_pivot=grid_get_pivot(td_file)
+      ENDIF
+
+      IF( il_pivot < 0 .OR. il_pivot > 1 )THEN
+         CALL logger_error("GRID GET PERIO: invalid pivot point index. "//&
+         &  "you should use grid_get_pivot to compute it")
+      ENDIF
 
       ! look for suitable variable
